/*
	Knihovna 3d vypoctu. v 1.0
	Adam Sadovsky 2000

	Poznamky:
		Veskere vypocty s realnymi cisli jsou definovany pomoci typu tip.
		Prostor vypoctu je pravotocivy.
		Souradnice promitaci plochy jsou levotocive. X jde doprava, Y nahoru, Z dopredu (smer pohledu na monitor)
		Uhly jsou odpocitavany od 3 hodiny proti smeru hodinovych rucicek.
*/

typedef double tip;

struct vektor {
  tip x, y, z;
};

struct bod {
  tip x, y, z;
};

struct obod {
  tip x, y, z;
};


void prumet(bod *A, obod *O, bod B, vektor up, vektor vp, tip d, int odk, int dok) {
/*
	Spocte prumety zadanych bodu do zadane roviny.
	Vstup:
	  *A 	- pole bodu, ktere se maji promitnout do roviny
	  B 	- stred roviny
	  up 	- normalovy vektor roviny, smeruje ve smeru pohledu (osa z vzhledem k rovine)
	  vp 	- vektor vyznacujici otoceni roviny okolo vektoru up (osa y vzhledem k rovine)
	  d		- vzdalenost perspektivy pro 0 se pocita bez perspektivy
	  odk	- od ktereho bodu chceme pocitat
	  dok	- do ktereho bodu ktere chceme pocitat

	Vystup:
	  *O    - pole obrazovych bodu zadanych od stredu roviny (plati odk a poc)
*/
 tip vv, k, l, m;	// vv - velikost vektoru, k - nasobek vektoru u, l - nasobek vektoru v, m - nasobek vektoru w
 tip con[5];		// konstanty
 vektor u, v, w;	// u - vektor smerujici do bodu A (z), v - jednotkovy vektor osy y, w - jednotkovy vektor osy x
 bod P;				// bod perspektivy
 vektor uh;         // pomocny vektor pro vypocet k s perspektivou.
 int i;
	/* spocti jednotkovy vektor up */
 con[1] = up.x*up.x + up.y*up.y + up.z*up.z;
 if (con[1] >= 0)
 vv = sqrt(con[1]);
 u.x = up.x/vv;
 u.y = up.y/vv;
 u.z = up.z/vv;
 uh.x = u.x;
 uh.y = u.y;
 uh.z = u.z;
	/* spocti jednotkovy vektor vp */
 con[1] = vp.x*vp.x + vp.y*vp.y + vp.z*vp.z;
 if (con[1] >= 0)
 vv = sqrt(con[1]);
 v.x = vp.x/vv;
 v.y = vp.y/vv;
 v.z = vp.z/vv;
	/* spocti jednotkovy vektor kolmy k up a vp */
 w.x = u.y*v.z - u.z*v.y;
 w.y = u.z*v.x - u.x*v.z;
 w.z = u.x*v.y - u.y*v.x;
	/* bez perspektivy */
 if (d == 0) {
   con[0] = 1/(u.x*v.y*w.z + v.x*w.y*u.z + w.x*u.y*v.z - w.x*v.y*u.z - u.x*w.y*v.z - v.x*u.y*w.z);
   for (i = odk; i < dok; i ++) {
	 k = ( (A[i].x - B.x)*v.y*w.z + v.x*w.y*(A[i].z - B.z) + w.x*(A[i].y - B.y)*v.z -
		   w.x*v.y*(A[i].z - B.z) - (A[i].x - B.x)*w.y*v.z - v.x*(A[i].y - B.y)*w.z ) * con[0];
	 l = ( u.x*(A[i].y - B.y)*w.z + (A[i].x - B.x)*w.y*u.z + w.x*u.y*(A[i].z - B.z) -
		   w.x*(A[i].y - B.y)*u.z - u.x*w.y*(A[i].z - B.z) - (A[i].x - B.x)*u.y*w.z ) * con[0];
	 m = ( u.x*v.y*(A[i].z - B.z) + v.x*(A[i].y - B.y)*u.z + (A[i].x - B.x)*u.y*v.z -
		   (A[i].x - B.x)*v.y*u.z - u.x*(A[i].y - B.y)*v.z - v.x*u.y*(A[i].z - B.z) ) * con[0];
	 O[i].x = m;
	 O[i].y = l;
	 O[i].z = k;
   }
 }
	/* s perspektivou */
 if (d != 0) {
   P.x = B.x - u.x*d;
   P.y = B.y - u.y*d;
   P.z = B.z - u.z*d;
   for (i = odk; i < dok; i ++) {
	 u.x = A[i].x - P.x;
	 u.y = A[i].y - P.y;
	 u.z = A[i].z - P.z;
   /*  tento blok je nutne spocitat pro zjisteni presne vzdalenosti bodu A v ose z */
   /*  o polovinu zpomaluje vypocet */
#ifndef ZET
//	 vv = sqrt(u.x*u.x + u.y*u.y + u.z*u.z);
//	 u.x = u.x/vv;
//	 u.y = u.y/vv;
//	 u.z = u.z/vv;
	 con[0] = 1/(uh.x*v.y*w.z + v.x*w.y*uh.z + w.x*uh.y*v.z - w.x*v.y*uh.z - uh.x*w.y*v.z - v.x*uh.y*w.z);
	 k = ( (A[i].x - B.x)*v.y*w.z + v.x*w.y*(A[i].z - B.z) + w.x*(A[i].y - B.y)*v.z -
		   w.x*v.y*(A[i].z - B.z) - (A[i].x - B.x)*w.y*v.z - v.x*(A[i].y - B.y)*w.z ) * con[0];
	 con[0] = 1/(u.x*v.y*w.z + v.x*w.y*u.z + w.x*u.y*v.z - w.x*v.y*u.z - u.x*w.y*v.z - v.x*u.y*w.z);
#else
	 con[0] = 1/(u.x*v.y*w.z + v.x*w.y*u.z + w.x*u.y*v.z - w.x*v.y*u.z - u.x*w.y*v.z - v.x*u.y*w.z);
	 k = ( (A[i].x - B.x)*v.y*w.z + v.x*w.y*(A[i].z - B.z) + w.x*(A[i].y - B.y)*v.z -
		   w.x*v.y*(A[i].z - B.z) - (A[i].x - B.x)*w.y*v.z - v.x*(A[i].y - B.y)*w.z ) * con[0];
#endif
	 l = ( u.x*(A[i].y - B.y)*w.z + (A[i].x - B.x)*w.y*u.z + w.x*u.y*(A[i].z - B.z) -
		   w.x*(A[i].y - B.y)*u.z - u.x*w.y*(A[i].z - B.z) - (A[i].x - B.x)*u.y*w.z ) * con[0];
	 m = ( u.x*v.y*(A[i].z - B.z) + v.x*(A[i].y - B.y)*u.z + (A[i].x - B.x)*u.y*v.z -
		   (A[i].x - B.x)*v.y*u.z - u.x*(A[i].y - B.y)*v.z - v.x*u.y*(A[i].z - B.z) ) * con[0];
	 O[i].x = m;
	 O[i].y = l;
	 O[i].z = k;
   }
 }
}

struct foot {
	bod B;
	vektor up, vp;
	tip alfa, beta, x, y, z;

	void step(tip diste) {
	  x += cos(alfa)*diste;
	  y += sin(alfa)*diste;
	}

	void strafe(tip diste) {
	  x += cos(alfa + PI/2)*diste;
	  y += sin(alfa + PI/2)*diste;
	}

	void rotate(tip rote) {
	  alfa += rote;
	}

	void look(tip looke) {
	  beta += looke;
	}

	void set(tip alfa0, tip beta0, tip x0, tip y0, tip z0) {
	  alfa = alfa0;
	  beta = beta0;
	  x = x0;
	  y = y0;
	  z = z0;
	  aktual();
	}

	void aktual() {
	  B.x = x;
	  B.y = y;
	  B.z = z;
	  up.x = cos(alfa)*cos(beta);
	  up.y = sin(alfa)*cos(beta);
	  up.z = sin(beta);
	  vp.x = cos(alfa)*cos(beta + PI/2);
	  vp.y = sin(alfa)*cos(beta + PI/2);
	  vp.z = sin(beta + PI/2);
	}
};

struct fly {
      public:
	bod B;
	vektor up, vp;
	tip alfa, beta, x, y, z;

	void step(tip diste) {
	  x += cos(alfa)*cos(beta)*diste;
	  y += sin(alfa)*cos(beta)*diste;
	  z += sin(beta)*diste;
	}

	void strafe(tip diste) {
	  x += cos(alfa + PI/2)*cos(beta)*diste;
	  y += sin(alfa + PI/2)*cos(beta)*diste;
	  z += sin(beta)*diste;
	}

	void rotate(tip rote) {
	  alfa += rote;
	}

	void look(tip looke) {
	  beta += looke;
	}

	void set(tip alfa0, tip beta0, tip x0, tip y0, tip z0) {
	  alfa = alfa0;
	  beta = beta0;
	  x = x0;
	  y = y0;
	  z = z0;
	  aktual();
	}

	void aktual() {
	  B.x = x;
	  B.y = y;
	  B.z = z;
	  up.x = cos(alfa)*cos(beta);
	  up.y = sin(alfa)*cos(beta);
	  up.z = sin(beta);
	  vp.x = cos(alfa)*cos(beta + PI/2);
	  vp.y = sin(alfa)*cos(beta + PI/2);
	  vp.z = sin(beta + PI/2);
	}
};

struct trote {
	bod B;
	vektor up, vp;
	tip alfa, beta, x, y, z, dist;

	void step(tip diste) {
	  dist -= diste;
	  if (dist < 0) dist = 0;
	}

	void rotate(tip rote) {
	  alfa += rote;
	}

	void look(tip looke) {
	  beta += looke;
	}

	void set(tip alfa0, tip beta0, tip x0, tip y0, tip z0, tip dist0) {
	  alfa = alfa0;
	  beta = beta0;
	  x = x0;
	  y = y0;
	  z = z0;
	  dist = dist0;
	  aktual();
	}

	void aktual() {
	  B.x = x + cos(alfa)*cos(beta)*dist;
	  B.y = y + sin(alfa)*cos(beta)*dist;
	  B.z = z + sin(beta)*dist;
	  up.x = x - B.x;
	  up.y = y - B.y;
	  up.z = z - B.z;
	  vp.x = cos(alfa)*cos(beta + PI/2);
	  vp.y = sin(alfa)*cos(beta + PI/2);
	  vp.z = sin(beta + PI/2);
	}

};
